Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC > Class Template Reference

Base-class for ternary Boolean propagators. More...

`#include <bool.hh>`

## Public Member Functions

| BoolTernary (Space &home, Propagator &p, BVA b0, BVB b1, BVC b2)
| Constructor for rewriting p during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low binary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| BoolTernary (Home home, BVA b0, BVB b1, BVC b2)
| BoolTernary (Space &home, BoolTernary &p)
| Constructor for cloning.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

BVA | x0
| Boolean view.
BVB | x1
| Boolean view.
BVC | x2
| Boolean view Constructor for posting.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class BVA, class BVB, class BVC>
class Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >

Base-class for ternary Boolean propagators.

Definition at line 77 of file bool.hh.

## Constructor & Destructor Documentation

## BoolTernary() [1/3]

template<class BVA, class BVB, class BVC>

Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::BoolTernary | ( | Home | home,
|  | BVA | b0,
|  | BVB | b1,
|  | BVC | b2 )

inline protected

Definition at line 93 of file base.hpp.

## BoolTernary() [2/3]

template<class BVA, class BVB, class BVC>

Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::BoolTernary | ( | Space & | home,
|  | BoolTernary< BVA, BVB, BVC > & | p )

inline protected

Constructor for cloning.

Definition at line 103 of file base.hpp.

## BoolTernary() [3/3]

template<class BVA, class BVB, class BVC>

Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::BoolTernary | ( | Space & | home,
|  | Propagator & | p,
|  | BVA | b0,
|  | BVB | b1,
|  | BVC | b2 )

inline

Constructor for rewriting p during cloning.

Definition at line 113 of file base.hpp.

## Member Function Documentation

## cost()

template<class BVA, class BVB, class BVC>

PropCost Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low binary).

Implements Gecode::Propagator.

Definition at line 123 of file base.hpp.

## reschedule()

template<class BVA, class BVB, class BVC>

void Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 129 of file base.hpp.

## dispose()

template<class BVA, class BVB, class BVC>

size_t Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 137 of file base.hpp.

## Member Data Documentation

## x0

template<class BVA, class BVB, class BVC>

BVA Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::x0

protected

Boolean view.

Definition at line 79 of file bool.hh.

## x1

template<class BVA, class BVB, class BVC>

BVB Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::x1

protected

Boolean view.

Definition at line 80 of file bool.hh.

## x2

template<class BVA, class BVB, class BVC>

BVC Gecode::Int::Bool::BoolTernary< BVA, BVB, BVC >::x2

protected

Boolean view Constructor for posting.

Definition at line 81 of file bool.hh.

The documentation for this class was generated from the following files:

- gecode/int/bool.hh
- gecode/int/bool/base.hpp